package jpa.test.bean;

import javax.persistence.*;


public class BasicMain {
	
	private EntityManager em01 = null;
	private EntityManager em02 = null;

	/**
	 * @param args
	 */
	public BasicMain() {
		// TODO ꂽ\bhEX^u
		
		try{
			
			
			EntityManagerFactory emf =
                Persistence.createEntityManagerFactory("TestPersistenceUnit");
			
			if(emf==null){
	            System.out.println("createEntityManagerFactory() == null");
	            System.exit(1);
	        }
			
			em01 = emf.createEntityManager();
			em02 = emf.createEntityManager();
			
            if(em01 == null){
			    System.out.println("em01 createEntityManager() == null");
            }
            if(em02 == null){
			    System.out.println("em02 createEntityManager() == null");
            }

    	    try {
    	        
    	        MyRunnable01 r01 = new MyRunnable01();
    	        MyRunnable02 r02 = new MyRunnable02();
    	        
    	        Thread t01 = new Thread(r01);
    	        Thread t02 = new Thread(r02);
    	        
    	        System.out.println("Thread01 start!");
    	        t01.start();
    	        System.out.println("Thread02 start!");
    	        t02.start();
    	    }
    	    catch(Throwable thw)
    	    {
    	        System.err.println("### UserAP catch! ###");
    	        thw.printStackTrace();
    	    }

            
			
		}catch(Throwable thr){
			thr.printStackTrace();
		}

	}
	
	
    class MyRunnable01 implements Runnable {
        
        public void run(){
            try {
            	/*
            	em01.getTransaction().begin();
                System.out.println("### Thread01 do find ###");
                em01.find(TestEntity.class,"001").showData();
                Thread.sleep(15000);
                System.out.println("### Thread01 do find ###");
                em01.find(TestEntity.class,"001").showData();
                em01.getTransaction().commit();
                System.out.println("### Thread01 exit ###");
                */
            } catch (Throwable thr ) {
            	System.out.println("### Thread01 error exit ###");
            	thr.printStackTrace() ;
            }
        }
    }

    class MyRunnable02 implements Runnable {
        
        public void run(){
            try {
            	em02.getTransaction().begin();
                Thread.sleep(10000);
                System.out.println("### Thread02 do find ###");
                TestEntity entity = new TestEntity();
                entity = em02.find(TestEntity.class,"001");                
                entity.showData();
                System.out.println("### Thread02 do delete ###");
                em02.remove(entity);
                System.out.println("### Thread02 do merge ###");
                em02.merge(entity);
                em02.getTransaction().commit();
                System.out.println("### Thread02 do exit ###");
            } catch (Throwable thr ) {
            	System.out.println("### Thread02 error exit ###");
                thr.printStackTrace() ;
            }
        }
    }

}
