package jpa.test.bean;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.NamedNativeQuery;
import javax.persistence.*;
import javax.persistence.InheritanceType;
import javax.persistence.QueryHint;
import javax.persistence.FetchType ;


@Entity
public class TestEntity
{
	

    public TestEntity(){
        
    }
    
    public TestEntity(String ldap ){
        this.ldap      = ldap;
        this.rock_num  =1;
    }
    
    public void showData(){
        System.out.println("LDAP = "+ ldap);
    }
    
	@Id
	@Column(name="LDAP")
    private String ldap;
    
    public String getLdap()
    {
        return ldap;
    }

    public void setLdap(String ldap)
    {
        this.ldap = ldap;
    }
    
	@Version
	private int rock_num;

	public int getRock_num() {
		return rock_num;
	}

	public void setRock_num(int rock_num) {
		this.rock_num = rock_num;
	}
	
}

